#!/bin/bash
############################################################
### Ultima modificao: 30/08/06
###
### Lembrando que os pacotes abaixo so para uma instalao 
### completa usando uma nica mquina.
### Se for utilizar um servidor de e-mails ou ldap, por exemplo, 
### de outra mquina, alguns pacotes sero desnecessrios.
### Vai depender de cada implementao.
### Leia todo esse script e ajuste as suas necessidades.
############################################################


### Instala todos os pacotes e dependncias necessrias ao Expresso.
### Esse processo  um pouco demorado e exige que os repositrios online
### estejam configurados.
### Descomente essa linha para resolver todas as dependncias do Expresso.
yast -i apache2 apache2-prefork apache2-mod_php5 apache2-mod_perl openssl openssl-devel php5 php5-devel php5-gd php5-imap php5-ldap php5-pgsql php5-fastcgi php5-mbstring php5-pear-auth_sasl postgresql postgresql-server openldap2 openldap2-client openldap2-devel openldap2-back-meta openldap2-back-perl db42 cyrus-imapd cyrus-sasl-devel cyrus-sasl cyrus-sasl-saslauthd postfix vim perl-Cyrus-IMAP imap-lib perl-Parse-RecDescent perl-TermReadKey perl-TermReadLine-Gnu perl-MLDBM perl-MLDBM-Sync perl-ldap perl-Apache-AuthNetLDAP perl-libwww-perl perl-HTML-Parser perl-Tie-IxHash perl-HTML-Tagset perl-Convert-ASN1 readline-devel readline zip unzip

echo -e "\n\n\n\n\n\n##########################################################\n"
echo -e "BEM VINDO A INSTALAO DO EXPRESSO LIVRE\n"
echo -e "Este script foi feito para rodar no sistema Linux Suse 10.1.\n"
echo -e "Qualquer outro sistema pode exigir modificaes neste script."
echo -e "\n##########################################################\n"
echo -e "Digite a mesma senha utilizada na configuracao do LDAP."
echo -ne "Esta senha sera utilizada para o usuario expresso-admin.\n"
echo "Senha: "
read LDAP_PWD
echo -e "\nDigite sua organizacao, exemplo: suporte: "
read ORG
echo -e "\nDigite seu dominio, exemplo: netcom.inf.br: "
read DOMAIN
echo -e "\nDigite o dc para o LDAP, exemplo: dc=netcom,dc=inf,dc=br: "
read DC_LDAP

echo "##############################################"
echo "###  DEFININDO AS VARIAVEIS ..."
echo "##############################################"

LDAP_DN="$DC_LDAP"
NOME=`echo $DOMAIN | awk -F . '{print $1}'`
LDAP_PWD_MD5=`slappasswd -v -s $LDAP_PWD -h {MD5}`
LDAP_PWD_MD5=`php5 ./arqs-conf-suse/regexp.php $LDAP_PWD_MD5`
HEADER_PWD=`php5 ./arqs-conf-suse/pass.php $LDAP_PWD`


echo "##############################################"
echo "###  PREPARANDO O POSTGRESQL ..."
echo "##############################################"

### Prepara a base de dados do Expresso baseada nas informaes fornecidas.
### No precisa ser executado se preferir fazer manualmente na primeira vez que acessar o expresso.
#sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/LDAP_PWD/$LDAP_PWD/g" -e "s/DOMAIN/$DOMAIN/g" -e "s/ORG/$ORG/g" ./arqs-conf-suse/expresso.dump > /tmp/expresso.dump

### Isso remover qualquer informao do postgresql.
### Comente essas linhas caso tenha outra base que no pode ser perdida.
### Caso descomente essas linhas, pode comentar o dropdb abaixo.
#rcpostgresql stop
#rm -Rf /var/lib/pgsql/data/
#rcpostgresql start

### Copia os arquivos de configurao do postgresql prontos para o Expresso.
cp /var/lib/pgsql/data/pg_hba.conf /var/lib/data/pgsql/pg_hba.conf.bkpexpresso
cp ./arqs-conf-suse/var/lib/pgsql/data/pg_hba.conf /var/lib/pgsql/data/
cp /var/lib/pgsql/data/postgresql.conf /var/lib/data/pgsql/postgresql.conf.bkpexpresso
cp ./arqs-conf-suse/var/lib/pgsql/data/postgresql.conf /var/lib/pgsql/data/

### Confirma se o postgresql est rodando.
rcpostgresql stop
sleep 3
rcpostgresql start

### Remove a base "expresso" para no dar problema caso ela j exista.
dropdb -U postgres expresso

### Cria a base "expresso" no formato latin1.
createdb -U postgres -E latin1 expresso

### Importa as tabelas geradas para a base "expresso".
### Isso pode ser feito pelo prprio expresso quando acess-lo pela primeira vez.
#psql -U postgres < /tmp/expresso.dump
#rcpostgresql restart
#rm /tmp/expresso.dump


echo "##############################################"
echo "###  PREPARANDO O APACHE ..."
echo "##############################################"

### A linha abaixo  somente para o Debian. No achei correspondente no Suse.
#apache2-ssl-certificate;
a2enmod rewrite;

### Se j existir uma instalao no expresso no apache, ela ser removida.
rm -Rf /srv/www/htdocs/expresso/

### Copia dos arquivos do expresso para o apache. Seta as permisses corretas.
cp -R -p ../../../expresso/ /srv/www/htdocs/
chown -R wwwrun:www /srv/www/htdocs/expresso/

### Troca os arquivos de configurao do apache pelos corretos do Expresso.
cp /etc/apache2/httpd.conf /etc/apache2/httpd.conf.bkpexpresso
cp ./arqs-conf-suse/etc/apache2/httpd.conf /etc/apache2/

cp /etc/apache2/server-tuning.conf /etc/apache2/server-tuning.conf.bkpexpresso
cp ./arqs-conf-suse/etc/apache2/server-tuning.conf /etc/apache2/

cp ./arqs-conf-suse/etc/apache2/vhosts.d/expresso.conf /etc/apache2/vhosts.d/

cp /etc/apache2/sysconfig.d/global.conf /etc/apache2/sysconfig.d/global.conf.bkpexpresso
cp ./arqs-conf-suse/etc/apache2/sysconfig.d/global.conf /etc/apache2/sysconfig.d/

### Troca o arquivo de configuraes do PHP com as exigncias do Expresso.
cp /etc/php5/apache2/php.ini /etc/php5/apache2/php.ini.bkpexpresso
cp ./arqs-conf-suse/etc/php5/apache2/php.ini /etc/php5/apache2/

### Apaga a pasta php_sessions para evitar problemas, caso ela j exista. Cria novamente com as permisses.
rm -Rf /php_sessions/
mkdir /php_sessions/
chmod -R 777 /php_sessions/

### Reinicia o apache.
rcapache2 restart


echo "##############################################"
echo "### PREPARANDO O OPENLDAP ..."
echo "##############################################"

### Gera o arquivo de configurao do Servidor LDAP personalizado e j o substitui.
sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/LDAP_PWD/$LDAP_PWD/g" ./arqs-conf-suse/etc/openldap/slapd.conf > /etc/openldap/slapd.conf

### Copia os schemas usados pelo Expresso.
cp ./arqs-conf-suse/etc/openldap/schema/* /etc/openldap/schema/
rcldap stop

### Gera a base padro do LDAP para o expresso.
sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/NOME/$NOME/g" -e "s/ORG/$ORG/g" -e "s/DOMAIN/$DOMAIN/g" ./arqs-conf-suse/expresso.ldif > /tmp/expresso.ldif

### Remove todas as entradas antigas do LDAP.
rm -Rf /var/lib/ldap/*
rcldap start

### Importa a base LDAP.
rcldap stop
slapadd -v -f /etc/openldap/slapd.conf -l /tmp/expresso.ldif
rcldap start
#rm /tmp/expresso.ldif


echo "##############################################"
echo "### PREPARANDO O SASL ..."
echo "##############################################"

### Adapta o SASL para o Expresso.
sed -e "s/LDAP_DN/$LDAP_DN/g" ./arqs-conf-suse/etc/saslauthd.conf > /etc/saslauthd.conf
cp ./arqs-conf-suse/etc/default/saslauthd /etc/default/

### Reinicia o SASL.
rcsaslauthd restart

echo "##############################################"
echo "### PREPARANDO O CYRUS ..."
echo "##############################################"

### Joga o arquivo de configurao do IMAP. Cotas esto desabilitadas!!!
cp ./arqs-conf-suse/etc/imapd.conf /etc/

### Copia o executvel do cyrus adaptado ao usurio expresso-admin. Somente para login.
cp -p ./arqs-conf-suse/usr/bin/cyradm_expresso /usr/bin/

### Reinicia os servios.
rccyrus restart
sleep 4

### Gera as pastas de IMAP para o expresso-admin.
./arqs-conf-suse/cyrus.pl $LDAP_PWD


echo "##############################################"
echo "### PREPARANDO O POSTFIX ..."
echo "##############################################"

### Gera o arquivo expresso-dominios baseado no domnio informado.
sed -e "s/DOMAIN/$DOMAIN/g" ./arqs-conf-suse/etc/postfix/expresso-dominios > /etc/postfix/expresso-dominios
postmap /etc/postfix/expresso-dominios

### Substitui o main.cf original por outro com as informao personalizadas.
sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/DOMAIN/$DOMAIN/g" ./arqs-conf-suse/etc/postfix/main.cf > /etc/postfix/main.cf
cp ./arqs-conf-suse/etc/postfix/master.cf /etc/postfix/
rcpostfix restart

### Adiciona os usurios "postfix" e "mail" e o grupo "postdrop".
groupadd postdrop
useradd postfix
useradd mail


echo "##############################################"
echo "### PREPARANDO A PASTA HOME DO EXPRESSO ..."
echo "##############################################"

# imapsync & mkpasswd

### Cria a pasta, copia os arquivos necessrios para ela e seta as devidas permisses.
mkdir /home/expressolivre
cp ./arqs-conf-suse/home/expressolivre/* /home/expressolivre/
chown -R wwwrun:www /home/expressolivre/

echo "##############################################"
echo "### PREPARANDO O HEADER_INC_PHP ..."
echo "##############################################"

### Recomendo comentar esta rotina para que o arquivo seja configurado pelo Administrador quando abrir o Expresso.
#sed -e "s/HEADER_PWD/$HEADER_PWD/g" ./arqs-conf-suse/header.inc.php > /srv/www/htdocs/expresso/header.inc.php
#chown wwwrun:www /srv/www/htdocs/expresso/header.inc.php

### Para garantir a configurao manual do header_inc_php, ele  removido.
rm -f /srv/www/htdocs/expresso/header.inc.php

insserv apache2 ; insserv postgresql ; insserv saslauthd ; insserv cyrus ; insserv ldap ; insserv -r nscd 

echo "##############################################"
echo "### TERMINADAS AS ROTINAS DE INSTALACAO DO EXPRESSO!"
echo "###"
echo "### Confira nas sadas do script se tudo ocorreu bem."
echo "###"
echo "### Instalador feito na versao Debian por"
echo "### Joao Alfredo Knopik Junior "
echo "### jakjr@celepar.pr.gov.br"
echo "###"
echo "### Reeditado, adaptado ao Suse e comentado por"
echo "### Marcus Augustus Pereira Burghardt"
echo "### marcus@netcom.inf.br"
echo "###"
echo "##############################################"
